{% extends 'admin/adminbase.html.twig' %}
{% import "macros/datatable.html.twig" as dt %}
{% import "macros/form.html.twig" as f %}

{% block moreCss %}
    <link href="{{ asset('dropify/css/dropify.css') }}" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.4.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/froala_editor.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/froala_style.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/code_view.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/colors.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/draggable.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/emoticons.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/image_manager.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/image.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/line_breaker.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/table.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/char_counter.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/video.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/fullscreen.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/file.min.css') }} ">
    <link rel="stylesheet" href="{{ asset('froalla/plugins/css/quick_insert.min.css') }} ">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.3.0/codemirror.min.css">

{% endblock %}

{% block body %}
    <div class="card-genossys">
        <h5>Paket dan Soal Tryout</h5>
        <div class="pb-5">
            <div class="float-right">
                <a class="btn btn-primary" href="#!" onclick="modalAdd()">Tambah Paket</a>
            </div>
        </div>
        {{ dt.datatable }}
    </div>

    <div class="p-3">

    </div>


    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle"
         aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document" style="max-width: 50%">
            <div class="modal-content">
                <form id="formCategori" method="post">
                    <input id="id" name="id" hidden>
                    <input id="action" name="action" hidden>
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Form Paket Try Out</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="subjek">Banner : </label>
                            <div class="input-field" id="div-img">
                                <input required type="file" name="banner" onchange="" id="banner" class="banner"
                                       data-min-height="10"
                                       data-height="150"
                                       accept="image/jpeg, image/jpg, image/png"
                                       data-allowed-file-extensions="jpg jpeg png"
                                />
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Nama Paket : </label>
                                <input required type="text" class="form-control" id="title" name="title"
                                       placeholder="Nama">
                            </div>
                            <div class="form-group col-md-6">
                                <label for="subjek">Deskripsi Paket : </label>
                                <input required type="text" class="form-control" id="description" name="description"
                                       placeholder="Deskripsi">
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Jenjang : </label>
                                <select required name="level" class="custom-select custom-select">
                                    {% for level in levels %}
                                        <option value="{{ level.getId() }}">{{ level.getName() }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                            <div class="form-group col-md-6">
                                <label for="subjek">Jenis Paket : </label>
                                <select required name="category" class="custom-select custom-select">
                                    {% for cat in cats %}
                                        <option value="{{ cat.getId() }}">{{ cat.getName() }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Status : </label>
                                <select required name="isActive" class="custom-select custom-select">
                                    <option value="1">Aktif</option>
                                    <option value="0">Tidak Aktif</option>
                                </select>
                            </div>
                            <div class="form-group col-md-6">
                                <label for="subjek">Pengerjaan urut? : </label>
                                <select required name="isStrict" class="custom-select custom-select">
                                    <option value="1">Aktif</option>
                                    <option value="0">Tidak Aktif</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Aktifkan Metode IRT? : </label>
                                <select required name="isIRT" class="custom-select custom-select">
                                    <option value="1">Aktif</option>
                                    <option value="0">Tidak Aktif</option>
                                </select>
                            </div>
                            <div class="form-group col-md-6">
                                <label for="subjek">Monetize : </label>
                                <div>
                                    <div class="custom-control custom-radio custom-control-inline">
                                        <input type="radio" value="1" checked id="isFreeTrue" name="isFree"
                                               class="custom-control-input">
                                        <label class="custom-control-label" for="isFreeTrue">Gratis</label>
                                    </div>
                                    <div class="custom-control custom-radio custom-control-inline">
                                        <input type="radio" value="0" id="isFreeFalse" name="isFree"
                                               class="custom-control-input">
                                        <label class="custom-control-label" for="isFreeFalse">Berbayar</label>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Kode Akses : </label>
                                <input type="text" class="form-control" id="codeAccess" name="codeAccess"
                                       placeholder="Kode">
                            </div>

                            <div class="form-group col-md-6">
                                <label for="subjek">Harga : </label>
                                <input type="text" disabled class="form-control" id="price" name="price"
                                       placeholder="Harga">
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="subjek">Panduan : </label>
                            <textarea required type="text" class="form-control" id="direction" name="direction"></textarea>
                        </div>
                        <div class="form-group">
                            <label for="subjek">Peraturan : </label>
                            <textarea required type="text" class="form-control" id="rules" name="rules"></textarea>
                        </div>

                        <div class="form-group">
                            <label for="subjek">Waktu Istirahat (Menit): </label>
                            <input required type="text" class="form-control" id="rules" name="restTime">
                        </div>
                        <div class="form-group">
                            <label for="subjek">Waktu Pengerjaan (Menit): </label>
                            <input required type="text" class="form-control" id="estimatedTime" name="estimatedTime">
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label for="subjek">Tanggal Mulai : </label>
                                <input type="date" class="form-control" id="startDay" name="startDay">
                            </div>

                            <div class="form-group col-md-6">
                                <label for="subjek">Tanggal berakhir : </label>
                                <input type="date" class="form-control" id="finalDay" name="finalDay">
                            </div>
                        </div>


                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Simpan</button>
                    </div>

                </form>
            </div>
        </div>
    </div>

{% endblock %}

{% block javascripts %}
    <script src="{{ asset('dropify/js/dropify.js') }}"></script>
    <script type="text/javascript"
            src="https://cdn.jsdelivr.net/npm/browser-image-compression@latest/dist/browser-image-compression.js"></script>
    <script src="{{ asset('etc/js/currency.js') }}"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.3.0/codemirror.min.js "></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.3.0/mode/xml/xml.min.js"></script>

    <script type="text/javascript" src="{{ asset('froalla/plugins/js/froala_editor.min.js') }} "></script>

    <script type="text/javascript" src="{{ asset('froalla/plugins/js/align.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/code_beautifier.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/code_view.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/colors.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/draggable.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/emoticons.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/font_size.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/font_family.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/image.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/file.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/image_manager.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/line_breaker.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/link.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/lists.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/paragraph_format.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/paragraph_style.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/video.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/table.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/url.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/entities.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/char_counter.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/inline_style.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/save.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/fullscreen.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/quote.min.js') }} "></script>
    <script type="text/javascript" src="{{ asset('froalla/plugins/js/quick_insert.min.js') }} "></script>
    <script src="{{ asset('dropify/js/dropify.js') }}"></script>
    <script type="text/javascript"
            src="https://cdn.jsdelivr.net/npm/browser-image-compression@latest/dist/browser-image-compression.js"></script>
    <script src="{{ asset('js/formatter.js') }}"></script>

    <script>
        var rules = new FroalaEditor('[name=rules]', {
            htmlAllowedTags: ['.*'],
            htmlAllowedAttrs: ['.*'],
        });

        var direction = new FroalaEditor('[name=direction]', {
            htmlAllowedTags: ['.*'],
            htmlAllowedAttrs: ['.*'],
        });

        function irtSuccess(param = {}) {
            if (param['code'] !== 200) {
                $("a#IRT").removeClass("disabled");
            }
            alert(param['msg']);
        }

        $(document).on("click", "#IRT", function () {
            let url = "{{ path("try-out-irt-calculation", { id : "zeg"} ) }}";
            var id = $(this).data('cred');
            url = url.replace("zeg", id);
            $(this).addClass("disabled");
            ajaxCall("irtSuccess", url, "POST", false);
        });

        $(document).ready(function () {


            currency('price');
            var fr = $('#formCategori');
            fr.submit(async function (e) {
                e.preventDefault(e);
                var formData = new FormData(this);

                alertify.confirm("Tambah Data Admin", "Apakah data yang anda masukkan sudah benar ?",
                    async function () {
                        if ($('#modal #banner').val()) {
                            let icon = await handleImageUpload($('#banner'));

                            formData.append('banner', icon, icon.name);
                        }
                        console.log(formData);
                        $("[type=submit]").attr("disabled", "disabled");

                        $.ajax({
                            type: "POST",
                            success: function (data) {
                                // console.log(data);
                                window.location.reload();
                            },
                            error: function (error) {
                                console.log("LOG ERROR", error);
                                $("[type=submit]").removeAttr("disabled");

                                // handle error
                            },
                            async: true,
                            data: formData,
                            cache: false,
                            contentType: false,
                            processData: false,
                            timeout: 60000
                        })
                    }, function () {

                    }
                )


            });

        });

        function modalAdd() {
            $('#modal #id').val('');
            $('#modal #action').val('add');
            $('#modal #name').val('');
            var icon = $('.banner').dropify({
                defaultFile: '',
                messages: {
                    'default': 'Masukkan Gambar Icon',
                    'replace': 'Drag and drop or click to replace',
                    'remove': 'Remove',
                    'error': 'Ooops, something wrong happended.'
                }
            });


            $('#modal').modal();
        }

        $(document).on('change', "[name='isFree']", function () {
            var v = $(this).val();
            if (v == 1) {
                $("#codeAccess").removeAttr("disabled");
                $("#codeAccess").attr("required",  "required");
                $("#price").attr("disabled", "disabled");
                $("#price").removeAttr("required");
            } else {
                $("#price").removeAttr("disabled");
                $("#price").attr("required",  "required");
                $("#codeAccess").attr("disabled", "disabled");
                $("#codeAccess").removeAttr("required");
            }
        });

        $(document).on('click', 'a#editData', function () {
            $('#modal #action').val('edit');
            $('#modal  [name=\'title\']').val($(this).data('title'));
            $('#modal  [name=\'level\']').val($(this).data('level'));
            $('#modal  [name=\'category\']').val($(this).data('cat'));
            $("#modal [name='description'] ").val($(this).data('description'));
            $("#modal [name='isActive'] ").val($(this).data('status') == "" ? "0" : $(this).data('status'));
            $("#modal [name='codeAccess']").val($(this).data('code'));
            $("#modal [name='isIRT']").val($(this).data('irt'));
            // $("#modal [name='direction']").froalaEditor('html.set', $(this).data('direction'));

            $("#modal [name='direction']").val($(this).data('direction'));
            $("#modal [name='rules']").val($(this).data('rules'));
            $("#modal [name='startDay']").val($(this).data('start'));
            $("#modal [name='finalDay']").val($(this).data('final'));
            rules.html.set($(this).data('rules'))
            direction.html.set($(this).data('direction'))
            // frl = null;
            // frl =  new FroalaEditor('[name=rules], [name=direction]', {
            //     htmlAllowedTags: ['.*'],
            //     htmlAllowedAttrs: ['.*'],
            // });
            $("#modal [name='restTime']").val($(this).data('rest'));
            $("#modal [name='isStrict']").val($(this).data('strict'));
            $("#modal [name='estimatedTime']").val($(this).data('estimated'));
            // $("#modal [name='banner']").val($(this).data('banner'));
            $('#modal #banner').removeAttr('required');

            var icon = $('.banner').dropify({
                defaultFile: '',
                messages: {
                    'default': 'Masukkan Gambar Icon',
                    'replace': 'Drag and drop or click to replace',
                    'remove': 'Remove',
                    'error': 'Ooops, something wrong happended.'
                }
            });
            icon = icon.data('dropify');
            icon.resetPreview();
            icon.clearElement();
            icon.settings.defaultFile = $(this).data('banner');
            icon.destroy();
            icon.init();

            if ($(this).data('free') == 1) {
                $("#isFreeTrue").attr("checked", "checked")
            } else {
                $("#isFreeFalse").attr("checked", "checked")
            }

            $('#modal #id').val($(this).data('cred'));


            $('#modal').modal();
        });

        function addData() {

        }


    </script>
    {{ dt.datatableJS(class, space, tableAction, tableFields,where) }}
{% endblock %}